#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <functional>
#include <iostream>
#include <string>

using namespace std;

typedef pair<int, char> KV;

const int E = 26;

string s;
int n;
KV freq[E];
int last[E];

int main()
{
    int i, j;

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> s;
    n = s.length();
    for (i = 0; i < n; i++) {
        freq[s[i]-'a'].first++;
    }
    for (i = 0; i < E; i++) {
        freq[i].second = i + 'a';
    }
    sort(freq+0, freq+E, greater<KV>());

    int max_freq = freq[0].first;
    int count = 1;
    while (count < E && freq[count].first == freq[0].first)
        count++;
    
    int gap;
    if (max_freq > 1) {
        gap = (n - count*max_freq) / (max_freq - 1) + count;
    } else {
        gap = 0;
    }

    memset(last, 0xff, sizeof(last));
    string ans(n, '.');
    for (i = 0; i < n; i++) {
        int k = -1;
        for (j = 0; j < E; j++) {
            if ((k == -1 || freq[j].first > freq[k].first) && 
                    (last[j] < 0 || i >= last[j] + gap)) {
                k = j;
            }
        }
        freq[k].first--;
        last[k] = i;
        ans[i] = freq[k].second;
    }
    cout << ans << endl;

    fclose(stdin); fclose(stdout);
}
